﻿Type=Service
Version=3.82
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#StartAtBoot: False
#End Region

Sub Process_Globals
	Dim logc As LogCat
	Dim loga(1) As String
	Dim logcn As Int 

	Dim name 	As String = "rudnik"		'device name
	Dim act_er	As String = "main"			'activity to start on error
	Dim act_ok	As String = "main"			'activity to start if message arrived
	Dim passwd 	As String = "123456"		'server password
	Dim purl 	As String = "https://www.XXX.net/push/push.reg.php"	'server link
	Dim gpid 	As String = "XXX"	'google project id
	
	Private hc 	As HttpClient
	Dim noti As Notification
End Sub
Sub Service_Create
	Log("*** SERVICE CREATE ***")
	logc.LogCatStart(loga,"logc")
	hc.InitializeAcceptAll("hc")
End Sub

Sub logc_LogCatData(Buffer() As Byte, Length As Int)
	Dim data As String 
	data = BytesToString(Buffer,0,Length,"UTF-8")
	If logcn < 10 Then 
		logstring(data)
		logcn = logcn + 1
	End If
End Sub

Sub logstring(str As String)
	Dim t, d As Int
	For t = 0 To str.length Step 2000
		d = t + 2000
		If d > str.Length Then d = str.length
		Log(str.SubString2(t, d)) 	
	Next
End Sub

Sub Service_Start (StartingIntent As Intent)
	Log("*** SERVICE START ***")
	Select StartingIntent.Action
		Case "com.google.android.c2dm.intent.REGISTRATION"
			HandleRegistrationResult(StartingIntent)
		Case "com.google.android.c2dm.intent.RECEIVE"
			MessageArrived(StartingIntent)
	End Select
End Sub
Sub MessageArrived (Intent As Intent)
	Dim data, did As String
	If Intent.HasExtra("did") Then did = Intent.GetExtra("did")
	If Intent.HasExtra("data") Then data = Intent.GetExtra("data")
	notify("PUSH", data, act_ok)
End Sub

Sub RegisterDevice (Unregister As Boolean)
	Dim i As Intent
	If Unregister Then		
		i.Initialize("com.google.android.c2dm.intent.UNREGISTER", "")
	Else
		i.Initialize("com.google.android.c2dm.intent.REGISTER", "")
		i.PutExtra("sender", gpid)
	End If
	Dim r As Reflector
	Dim i2 As Intent
	i2 = r.CreateObject("android.content.Intent")
	Dim pi As Object
	pi = r.RunStaticMethod("android.app.PendingIntent", "getBroadcast", Array As Object(r.GetContext, 0, i2, 0), Array As String("android.content.Context", "java.lang.int", "android.content.Intent", "java.lang.int"))
	i.PutExtra("app", pi)
	StartService(i)
End Sub

Sub HandleRegistrationResult(Intent As Intent)
	Dim req As HttpRequest
	If Intent.HasExtra("error") Then
		notify("PUSH ERROR 1", Intent.GetExtra("error"), act_er)
	Else If Intent.HasExtra("unregistered") Then
		req.InitializeGet(purl & "?passwd=" & passwd & "&name=" & name)
		hc.Execute(req, 2) 
	Else If Intent.HasExtra("registration_id") Then
		Dim rid As String
		rid = Intent.GetExtra("registration_id")
		req.InitializeGet(purl & "?passwd=" & passwd & "&name=" & name & "&id=" & rid)
		hc.Execute(req, 1) 
	End If
End Sub

Sub hc_ResponseSuccess (Response As HttpResponse, TaskId As Int)
	Dim str As String = Response.GetString("UTF8") 
	If str.StartsWith("ACK") Then
		If TaskId = 1 Then
			ToastMessageShow("Registered", True)
		Else 
			ToastMessageShow("Unregistered", True)
		End If
	Else
		notify("PUSH ERROR 3", str, act_er)
	End If
End Sub

Sub hc_ResponseError (Response As HttpResponse, Reason As String, StatusCode As Int, TaskId As Int)
	notify("PUSH ERROR 2", Reason, act_er)
	Log ("*** hc_ResponseError reason:" & Reason & " ***")
End Sub

'####################### THIS IS FOR TESTING ###############################################################################################################
Sub sendreq()
	Log("*** Send Request " & purl & " ***")
	Dim req As HttpRequest
	Dim rid As String = "testid"
	'req.InitializeGet(url & "?dpasswd=" & passwd & "&name=" & name & "&id=" & rid)
	req.InitializeGet(purl)
	hc.Execute(req, 1)
End Sub

Sub notify(head As String, mess As String, act As String)
	noti.Initialize
	noti.SetInfo(head, mess, act)
	noti.Light = True
	noti.Sound = True
	noti.Vibrate = True
	noti.AutoCancel = True
	noti.Icon = "icon"
	noti.notify(1)	
End Sub

Sub Service_Destroy
	Log("*** SERVICE DESTROY ***")
	logc.LogCatStop()	
End Sub
